!> @file m_random.f90
!! Additional module for the FishMet model: High level interface for
!! random numbers.

! ------------------------------------------------------------------------------
! Copyright notice:
!   Copyright (c) 2015-2024 Sergey Budaev
! ------------------------------------------------------------------------------

!*******************************************************************************
! PURPOSE:
!   Working with random numbers. Init random seed, generate random numbers
!
! NOTE ON PRECISION:
!  Single precision is the default in all generic interfaces (i.e. when there
!  is any interface ambiguity, single precision random procss are always
!  invoked).
!
! SUPPORTED COMPILERS:
!  GNU Fortran, Intel Fortran, Oracle Solaris Studio Fortran
!*******************************************************************************
module BASE_RANDOM

implicit none

! Precision constants
integer, parameter, private :: R4 = selected_real_kind(6,   37)
integer, parameter, private :: dp = selected_real_kind(15,  307)
integer, parameter, private :: QP = selected_real_kind(33, 4931)

! Module name for the DEBUG LOGGER: every function/sub must also have
! the PROCNAME parameter referring to its name. This is done for the Debug
! Logger module. Each module must also have a DEBUG Logger subroutine, that
! is a wrapper to module LOGGER (or perhaps any other that is being used)
!   procedure name PROCNAME
character (len=*), private, parameter :: MODNAME = "BASE_RANDOM"

! Set the debug mode to ON or OFF, in the debug mode, events are written to
! the log, determined by the LOG_DBG subroutine, normally, a wrapper to the
! module LOGGER. May also define integer DEBUG_LEVEL parameter...
logical, private, parameter :: IS_DEBUG = .FALSE.

! Sufficiently great maximum unit, in CSV_IO provided globally
integer, private, parameter :: MAX_UNIT=500

interface RAND_R4                 ! Uniform random numbers, standard and
  module procedure RAND_VAL_R4    ! renormalised to arbitrary range
  module procedure RAND_RENORMALISED_R4
  module procedure RAND_RENORMALISED_R4I
end interface RAND_R4

interface RAND_R8                 ! Uniform random numbers, standard and
  module procedure RAND_VAL_R8    ! renormalised to arbitrary range
  module procedure RAND_RENORMALISED_R8
  module procedure RAND_RENORMALISED_R8I
end interface RAND_R8

!-------------------------------------------------------------------------------
contains  !-----[ SUBROUTINES AND FUNCTIONS FOLLOW ]----------------------------

subroutine RANDOM_SEED_INIT()
!*******************************************************************************
! RANDOM_SEED_INIT_SIMPLE
! PURPOSE: initialises the random seed
! CALL PARAMETERS: none
! Note: A simple non-parallel version of RANDOM_SEED_INIT from BASE_UTILS of
!       HEDTOOLS is pasted here instead of non-portable version native for this
!       module from HEDTOOLS. This is because the later requires autogenerated
!       header files specific to compiler. It is just simpler.
!*******************************************************************************

  implicit none

  integer :: i, n, clock                ! DEFAULT INTEGER type, for portability
  integer, dimension(:), allocatable :: seed

  ! Subroutine name for DEBUG LOGGER
  character (len=*), parameter :: PROCNAME = "RANDOM_SEED_INIT_SIMPLE"

  !-----------------------------------------------------------------------------

  call random_seed(size = n)
  allocate(seed(n))

  call system_clock(count=clock)

  seed = clock + 37 * (/ (i - 1, i = 1, n) /)
  call random_seed(PUT = seed)

  deallocate(seed)

end subroutine RANDOM_SEED_INIT

!-------------------------------------------------------------------------------

function RAND_VAL_R4() result (randreal)
! Standard (trivial) wrapper for random real (0.0 <= r < 1.0)
! Notes: On some systems the several PRNGs functions may use different
!        algorithms e.g see ran (standard, from DEC) as well as lcrans and
!        addrans (better but slower). This uses the standard implementation
!        random_number. In particular, for GNU gfortran ran is provided for
!        backwards compatibility with GNU Fortran 77. It implements a simple
!        modulo generator as provided by g77. For new code, one should
!        consider the use of random_number as it implements a superior
!        algorithm. This random_number is just used in this function.

  implicit none
  real(kind=R4) :: randreal

  ! Subroutine name for DEBUG LOGGER
  character (len=*), parameter :: PROCNAME = "RAND_R4"

  call random_number(randreal)

end function RAND_VAL_R4

!-------------------------------------------------------------------------------

function RAND_VAL_R8() result (randreal)
! Standard (trivial) wrapper for random real (0.0 <= r < 1.0)

  implicit none
  real (kind=dp) :: randreal

  ! Subroutine name for DEBUG LOGGER
  character (len=*), parameter :: PROCNAME = "RAND_R8"

  call random_number(randreal)

end function RAND_VAL_R8

!-------------------------------------------------------------------------------

function RAND_I(a, b) result (randint)
! trivial random integer (a <= r <= b)

  implicit none
  integer :: randint
  integer, intent(in) :: a, b
  integer :: a_here, b_here, tmp

  ! Subroutine name for DEBUG LOGGER
  character (len=*), parameter :: PROCNAME = "RAND_I"

  a_here = a
  b_here = b

  if (a_here > b_here) then ! just swap values
    tmp=a_here
    a_here = b_here
    b_here = tmp
  end if

  ! Use int or floor? floor returns more homogeneous numbers if negative
  ! integers are in the range. With positive arguments int and floor eqivalent.
  ! Note: int(-0.2)= 0, floor(-0.2)=-1
  !       int(+0.2)= 0, floor(+0.2)= 0 , so with int there is a small local
  !       raise in the density function, not good.
  randint = a + floor(RAND_R4() * (b - a + 1))

end function RAND_I

!-------------------------------------------------------------------------------

function RAND_STRING(length, char_start, char_end) result (out_string)
!*******************************************************************************
! RAND_STRING
! PURPOSE: returns a string composed of random characters.
! PARAMETERS: integer string length, optional integers defining the range
!             of the ASCII character codes for the string, if they are not set,
!             the character range is defined in the ASCII codes 48:122 (i.e.
!             numbers, 48:57, sime special symbols and Latin alphanumeric
!             characters 65:122)
!*******************************************************************************

  ! Parameters
  integer, intent(in) :: length
  integer, optional, intent(in) :: char_start, char_end

  ! Function value
  character(len=length) :: out_string

  ! local variables
  integer :: i
  integer :: char_start_here, char_end_here

  if (present(char_start)) then
    char_start_here = char_start
  else
    char_start_here = 32
  end if

  if (present(char_end)) then
    char_end_here = char_end
  else
    char_end_here = 122
  end if

  ! produce the random string
  do i = 1, length
    out_string(i:i) = achar(RAND_I(char_start_here, char_end_here))
  end do

end function RAND_STRING

!-------------------------------------------------------------------------------

function RAND_RENORMALISED_R4(A, B) result(s_val)
!*******************************************************************************
! RAND_RENORMALISE_R4
! PURPOSE: Produce uniform random number renormalised from 0..1 to any arbitrary
!          range A..B.
!*******************************************************************************

  implicit none
  real(kind=R4):: s_val
  real(kind=R4):: A, B

  s_val = A+RAND_VAL_R4()*(B-A)

end function RAND_RENORMALISED_R4

function RAND_RENORMALISED_R4I(A, B) result(s_val)
!*******************************************************************************
! RAND_RENORMALISE_R4 for integer range
! PURPOSE: Produce uniform random number renormalised from 0..1 to any arbitrary
!          range A..B.
!*******************************************************************************

  implicit none
  real(kind=R4):: s_val
  integer:: A, B

  s_val = real(A,R4)+RAND_VAL_R4()*(real(B,R4)-real(A,R4))

end function RAND_RENORMALISED_R4I

!-------------------------------------------------------------------------------

function RAND_RENORMALISED_R8(A, B) result(s_val)
!*******************************************************************************
! RAND_RENORMALISE_R8
! PURPOSE: Produce uniform random number renormalised from 0..1 to any arbitrary
!          range A..B.
!*******************************************************************************

  implicit none
  real(kind=dp):: s_val
  real(kind=dp):: A, B

  s_val = A+RAND_VAL_R8()*(B-A)

end function RAND_RENORMALISED_R8

function RAND_RENORMALISED_R8I(A, B) result(s_val)
!*******************************************************************************
! RAND_RENORMALISE_R8
! PURPOSE: Produce uniform random number renormalised from 0..1 to any arbitrary
!          range A..B.
!*******************************************************************************

  implicit none
  real(kind=dp):: s_val
  integer :: A, B

  s_val = real(A,DP)+RAND_VAL_R8()*(real(B,DP)-real(A,DP))

end function RAND_RENORMALISED_R8I

end module BASE_RANDOM  ! <EOF>
